<template>
  <v-card class="registration elevation-0">
    <v-row
      justify="center"
      align="center"
    >
      <v-col cols="6" lg="5">
        <v-card-title
          class="px-0 blue-grey-text text-darken-4"
        >
          Регистрация
        </v-card-title>
        <v-form
          ref="form"
          v-model="valid"
        >
          <v-text-field
            v-model="name"
            name="name"
            :rules="fillRules"
            label="ФИО"
            required
          />
          <v-text-field
            v-model="email"
            name="email"
            :rules="emailRules"
            label="E-mail"
            required
          />
          <v-combobox
            v-model="role"
            :items="roles"
            :rules="fillRules"
            label="Роль"
          />
          <v-text-field
            v-model="password"
            type="password"
            :rules="fillRules"
            label="Придумайте пароль"
            required
          />
          <v-btn
            color="success"
            class="mt-6"
            @click="registration"
          >
            Регистрация
          </v-btn>
          <v-btn
            color="blue-grey darken-4"
            dark
            class="mt-6 ml-4"
            :to="{ name: 'Auth' }"
          >
            Авторизация
          </v-btn>
        </v-form>
      </v-col>
    </v-row>
  </v-card>
</template>

<script>
import api from '@/api';
import { mapAction } from 'vuex';

export default {
  name: 'RegistrationPage',
  data: () => ({
    valid: true,
    password: '',
    email: '',
    role: '',
    name: '',
    emailRules: [
      v => !!v || 'Необходимо заполнить',
      v => /.+@.+\..+/.test(v) || 'Некорректный Email',
    ],
    fillRules: [
       v => !!v || 'Необходимо заполнить',
    ],
    roles: [
      {
        text: 'Преподаватель',
        value: 'teacher'
      },
      {
        text: 'Ученик',
        value: 'student'
      },
    ]
  }),

  methods: {
    async registration() {
      if (!this.valid) return;
      
      const { err } = await api.common.registration({
        email: this.email,
        password: this.password,
        role: this.role.value,
        name: this.name
      });

      if (err) {
        this.errorText = err;
        return;
      } 

      this.$router.push({ name: 'Auth' })
    },
  },
}
</script>

<style lang="stylus" scoped>
.registration {
  height 100%
  display flex
  align-items center
}
</style>


